#!/usr/bin/perl
#
# calls the c++ 'codechecker' for all C files.
#
#    ========== licence begin  GPL
#    Copyright (C) 2001 SAP AG
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#    ========== licence end
#


use Env;
use Getopt::Std;

if ( @ARGV != 0 )  {

  print <DATA>;
  exit 1;
}

my $tmpfile = "$TMP/ccall.prt";

open(SAVEOUT, ">&STDOUT");
open(STDOUT, ">$tmpfile");

@ARGV = ("-m", "all");
do "$TOOL/bin/imf$TOOLEXT";
if ( $@ ) { die "Error while executing imf$TOOLEXT: $@" }

close(STDOUT);
open(STDOUT, ">&SAVEOUT");

open(FILE_IN, "<$tmpfile");
@allsrc = <FILE_IN>;
close(FILE_IN);

foreach ( @allsrc ) {

    chop;

    if ( /.*\.(c|h|cpp)$/ ) {
	print "check $_\n";
	system("codecheck -v $_");
    }
}


__DATA__


  calls the c++ 'codechecker' for all C files.

  USAGE: ccall


